NEWIODELAY EQU OUT 0EBh, AL 

PCIAddr   dd 0
SMBusAddr dw 0

VDID_PIIX4    =71138086h; 82371AB/EB/MB PIIX4/E/M Power Management Controller.
VDID_VIA596A  =30501106h; VT82C596/A/B Power Management Controller
VDID_VIA686A  =30571106h; VT82C686/A/B Power Management Controller

VDID_AMD756PM =740B1022h; AMD-756 Power Management Controller
VDID_AMD766PM =74131022h; AMD-766 Power Management Controller
VDID_AMD768PM =74431022h; AMD-768 ACPI Controller
VDID_AMD8111PM=746B1022h; AMD-8111 ACPI System Management Controller

;********************************************
;*    SMBus              *
;*   SMBusAddr                    *
;*  EAX PCI                           *
;********************************************

FindSMBusAddr:
PUSH EBX
PUSH ECX
PUSH EDX

MOV EBX, 0C0500h      ;  SMBus
MOV ECX, 80000000h    ;    
.Label1:

AND ECX, 0FFFFFF00h   ; 
MOV EAX, ECX
MOV DX,  0CF8h
OUT DX,  EAX          ;  
MOV DX,  0CFCh
IN  EAX, DX           ;  
CMP EAX, 0FFFFFFFFh   ;   .
JE  .Label2

CMP EAX, VDID_VIA596A
JNE .Label9

ADD ECX, 80h          ;  VDID_VIA596A
MOV EAX, ECX
MOV DX,  0CF8h
OUT DX,  EAX          ;  
MOV DX,  0CFCh
IN  EAX, DX           ;  

JMP .Label3

.Label9:
CMP EAX, VDID_VIA686A
JE  .Label7
CMP EAX, VDID_PIIX4
JNE .Label8
.Label7:

ADD ECX, 90h          ;  VDID_PIIX4  VDID_VIA686A
MOV EAX, ECX
MOV DX,  0CF8h
OUT DX,  EAX          ;  
MOV DX,  0CFCh
IN  EAX, DX           ;  

JMP .Label3

.Label8:
CMP EAX, VDID_AMD756PM
JE  .label5
CMP EAX, VDID_AMD766PM
JE  .label5
CMP EAX, VDID_AMD768PM
JE  .label5
CMP EAX, VDID_AMD8111PM
JE  .label5
JMP .Label4
.label5:

ADD ECX, 58h          ;  VDID_AMD_PM 
MOV EAX, ECX
MOV DX,  0CF8h
OUT DX,  EAX          ;  
MOV DX,  0CFCh
IN  EAX, DX           ;  

JMP .Label3


.Label4:
ADD ECX, 08           ;     
MOV EAX, ECX
MOV DX,  0CF8h
OUT DX,  EAX          ;  
MOV DX,  0CFCh
IN  EAX, DX           ;  
SHR EAX, 8            ;
CMP EAX, EBX  

JNE .Label2       
MOV CL,  10h-4h       ;   SMBus

MOV EBX, 6
.Label6:

ADD ECX, 4h           ; BAR1-BAR6 
MOV EAX, ECX
MOV DX,  0CF8h
OUT DX,  EAX          ;  
MOV DX,  0CFCh
IN  EAX, DX           ;  
TEST AX, 0FFF0h
JNZ  .Label3          ; 
DEC EBX
JNZ .Label6

JMP .Label3           ; 

.Label2:
ADD ECX, 256

              
CMP ECX, 80FFFF00h    ;  256 .               
JNE .Label1
MOV ECX, 0FFFFFFFFh   ;  
MOV EAX, 0
.Label3:
AND AX,  0FFF0h       ;  4 .
MOV [SMBusAddr],AX    ;   SMBus

XOR EAX, EAX          ;   PCI
MOV DX,  0CF8h        ;    .
OUT DX,  EAX          ;

AND ECX, 0FFFFFF00h   ;   
MOV EAX, ECX
POP EDX
POP ECX
POP EBX
RET
